required steps:
===============

1.) install a fresh wildfly-10.1.0.Final
2.) build the project using maven or use the 'playground-prj.ear' from the root folder
3.) copy the resulting artifact 'playground-prj.ear' to $JBOSS_HOME/standalone/deployemnts
4.) start the server

You should see the following output:

~~~
15:57:17,348 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) epoch[0]: 1509231600, instant: 2017-10-28T23:00:00Z, toString: 2017-10-29T01:00+02:00[Europe/Berlin], withZoneSameInstant: 2017-10-29T01:00+02:00[Europe/Berlin], offset: +02:00
15:57:18,091 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) epoch[1]: 1509235200, instant: 2017-10-29T00:00:00Z, toString: 2017-10-29T02:00+02:00[Europe/Berlin], withZoneSameInstant: 2017-10-29T02:00+02:00[Europe/Berlin], offset: +02:00
15:57:18,094 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) epoch[2]: 1509238800, instant: 2017-10-29T01:00:00Z, toString: 2017-10-29T02:00+01:00[Europe/Berlin], withZoneSameInstant: 2017-10-29T02:00+01:00[Europe/Berlin], offset: +01:00
15:57:18,101 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) ------------------------------------------------------------------------------------------------
15:57:18,101 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) -- Now read with Id on Value --
15:57:18,102 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) -- here all ZonedDateTimes are correct...
15:57:18,102 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) ------------------------------------------------------------------------------------------------
15:57:18,198 INFO  [org.hibernate.hql.internal.QueryTranslatorFactoryInitiator] (ServerService Thread Pool -- 58) HHH000397: Using ASTQueryTranslatorFactory
15:57:18,791 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) epoch[0]: 1509231600, instant: 2017-10-28T23:00:00Z, toString: 2017-10-29T01:00+02:00[Europe/Berlin], withZoneSameInstant: 2017-10-29T01:00+02:00[Europe/Berlin], offset: +02:00
15:57:18,791 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) epoch[1]: 1509235200, instant: 2017-10-29T00:00:00Z, toString: 2017-10-29T02:00+02:00[Europe/Berlin], withZoneSameInstant: 2017-10-29T02:00+02:00[Europe/Berlin], offset: +02:00
15:57:18,791 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) epoch[2]: 1509238800, instant: 2017-10-29T01:00:00Z, toString: 2017-10-29T02:00+01:00[Europe/Berlin], withZoneSameInstant: 2017-10-29T02:00+01:00[Europe/Berlin], offset: +01:00
15:57:18,791 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) ------------------------------------------------------------------------------------------------
15:57:18,791 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) -- Now read with Id on Timestamp --
15:57:18,792 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) -- here the epoch[1] is wrong...
15:57:18,792 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) ------------------------------------------------------------------------------------------------
15:57:18,806 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) epoch[0]: 1509231600, instant: 2017-10-28T23:00:00Z, toString: 2017-10-29T01:00+02:00[Europe/Berlin], withZoneSameInstant: 2017-10-29T01:00+02:00[Europe/Berlin], offset: +02:00
15:57:18,806 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) epoch[1]: 1509238800, instant: 2017-10-29T01:00:00Z, toString: 2017-10-29T02:00+01:00[Europe/Berlin], withZoneSameInstant: 2017-10-29T02:00+01:00[Europe/Berlin], offset: +01:00
15:57:18,806 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) epoch[2]: 1509238800, instant: 2017-10-29T01:00:00Z, toString: 2017-10-29T02:00+01:00[Europe/Berlin], withZoneSameInstant: 2017-10-29T02:00+01:00[Europe/Berlin], offset: +01:00
15:57:18,807 INFO  [org.jboss.jbaesner.playground.jpa.TimeTestStartupBean] (ServerService Thread Pool -- 58) ------------------------------------------------------------------------------------------------
~~~

As can be seen the epoch[1] timestamp value is different, depending on the fact whether the entities Timestamp getter is annotated with @Id or not...
